/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package battle;

/**
 *
 * @author jub
 * Object that adds bullets to the world.
 */
public class Gun {

    private SElement element;
    private World world;
    private int shootStep;
    private int shootDelay;
    private int coolDownTime;
    private int overHeatStep;

    /**Constructor, creates a Gun object.
    @param _world World in which the bullets will be shot.
     * @param _element SElement to which this Gun belongs.
     */
    Gun(World _world, SElement _element) {
        world = _world;
        element = _element;
        shootStep = 0;
        shootDelay = 10;
        coolDownTime = 10;
        overHeatStep = 20;
    }

    /**Creates a bullet in the world with proper direction and initial position.*/
    public void fire() {
        if (shootStep++ % (overHeatStep + coolDownTime) < overHeatStep) {
            if (shootStep % shootDelay == 0 || (int) (Math.random() * 10) == 0) {
                world.postAddElement(new Bullet(
                        element.getId(),
                        element.getColor(),
                        element.getPos(),
                        element.getDir(),
                        (int) (element.getSize() / 2), 2));
            }
        }
    }
}
